; tabstop=8
;
;
	relaxed on

	org	$c000

	jp	EXROMREAD
	jp	EXROMBOOT
RAMSIZE:
	db	"2"			; 16K="1"/32K="2"/gBASIC16K="3"/gBASIC32K="4"

EXROMREAD:
	di
	in	a,($f0)
	ld	(DT_PORT_F0H),a
	in	a,($f2)
	ld	(DT_PORT_F2H),a

	ld	a,$71
	out	($f0),a			; 0x4000-0x7FFF ̓ǂݏoOROM
	ld	a,$55
	out	($f2),a			; 0x4000-0x7FFF ݂̏RAM

	ld	hl,$4000
	ld	de,$4000
	ld	bc,$4000
	ldir				; 0x4000-0x7FFF ROM̓eRAMɏ

	ld	a,(DT_PORT_F0H)		; |[gɖ߂
	out	($f0),a
	ld	a,(DT_PORT_F2H)
	out	($f2),a
	ei
	ret

DT_PORT_F0H:
	db	$00
DT_PORT_F2H:
	db	$00

EXROMBOOT:
	di

	ld	hl,$0000
	ld	de,$0000
	ld	bc,$4000

	ld	a,(RAMSIZE)		; gBASICgpA"3"or"4"
	cp	"3"
	jr	c,.no_ex1
	ld	bc,$6000

.no_ex1:
	ld	a,$11
	out	($f0),a			; 0x0000-0x7FFF ̓ǂݏoROM
	ld	a,$55
	out	($f2),a			; 0x0000-0xFFFF ݂̏RAM

	ldir				; 0x0000-0x3FFF(5FFF) ROM̓eRs[

	ld	a,$dd
	out	($f0),a			; 0x0000-0x7FFF ̓ǂݏoRAM


; BASIC-ROM Ƀpb`𓖂Ă

	; MODE ̐ݒiMODE1/2j
	; {̓L[{[hςȂŃ[hÎAS/Wŋݒ肷

	ld	hl,$10de
	ld	a,$00			; NOP
	ld	(hl),a
	inc	hl
	ld	(hl),a
	inc	hl
	ld	(hl),a
	inc	hl
	ld	(hl),a
	inc	hl
	ld	a,$3e			; LD A,"1"`"4"
	ld	(hl),a
	inc	hl
	ld	a,(RAMSIZE)		; 16K̎"1"or"3"A32K̎"2"or"4"
	ld	(hl),a


	; RAMgROMƔFi̓ǂݏoݒ̕ύXj

	ld	a,$dd			; 0x0000-0x7FFF ̓ǂݏoRAM
	ld	($2c9c),a
	ld	a,$50			; 0x0000-0x7FFF ݂̏oȂ悤ɂ
	ld	($2c9e),a


	; ROMJ[gbW̔FvO̕ύX

	ld	hl,$3c67
	ld	a,$c9			; RET
	ld	(hl),a			; ROMJ[gbW̃`FbNrőł؂点

	ld	a,(RAMSIZE)		; gBASICgpA"3"or"4"
	cp	"3"
	jr	c,.no_ex2

	ld	a,$c3			; JP
	ld	(hl),a			; "CD"̃`FbN΂
	inc	hl
	ld	a,$c8
	ld	(hl),a
	inc	hl
	ld	a,$5f
	ld	(hl),a

	ld	hl,$5fdf
	ld	a,$c0			; RET NZ
	ld	(hl),a			; 0x6000ȍ~̏[`rőł؂
	inc	hl
	ld	a,$00			; NOP
	ld	(hl),a


.no_ex2:
	ld	a,($0e34)		; ROMeǂݏoA@ɂăpb`ς
	cp	$21			; mk2
	jr	z,.patch_mk2
	cp	$04			; 66
	jr	z,.patch_66
	cp	$d3			; mk2SR/66SR
	jr	z,.patch_sr

	halt				; ROMʕs...

.patch_mk2:
	ld	a,$2d			; 0x0000-0x3FFF RAMɁipb`j
	ld	($0e34),a
	ld	a,$dd			; 0x0000-0x7FFF RAMɁipb`j
	ld	($0e43),a
	jp	$0000			; N60m-BASIC̃u[g

.patch_66:
	jp	$0000			; N66-BASIC̃u[g

.patch_sr:
	ld	a,$6d			; 0x0000-0x3FFF RAMɁipb`j
	ld	($0e33),a
	ld	a,$dd			; 0x0000-0x7FFF RAMɁipb`j
	ld	($0e3e),a
	jp	$0000			; N66-BASIC̃u[g


end
